// Pile.h : une pile d’entiers

#ifndef PILE_H
#define PILE_H

#include <assert.h>
#include <iostream>

using namespace std;

const int MAX = 10;

class Pile {

  // Injection dans un flot

   friend ostream& operator<<(ostream& s, const Pile& p);

 public:

  // Allocations

            Pile(void);
            Pile(const Pile& p);
            Pile& operator=(const Pile& p);
   virtual ~Pile(void);

  // Inspecteurs

   bool estVide(void) const;
   bool estPleine(void) const;
   int sommet(void) const;

  // Manipulateurs

   void empiler(int x);
   int depiler(void);

 private:
   int _pile[MAX];
   int _taille;

}; // fin de la classe Pile

#endif
