#include <assert.h>
#include <iostream>

using namespace std;

const int MAX = 10;

template <class T>
struct stack {
  T t[MAX];
  int n;
};

stack<int> t1;
stack< pair<int,char*> > t2;  // Le type pair existe directement en C++ ...

template <class T>
bool isEmpty(const stack<T>& s) { return s.n == 0; }

template <class T>
bool isFull(const stack<T>& s) { return s.n == MAX; }

template <class T>
const T& top(const stack<T>& s) {
  assert(!isEmpty(s));
  return s.t[s.n - 1];
}

template <class T>
void push(stack<T>& s, const T& t) {
  assert(!isFull(s));
  s.t[s.n++] = t;
}

template <class T>
T pop(stack<T>& s) {
  assert(!isEmpty(s));
  return s.t[--s.n];
}

int main(void)
{
 pair<int,char> p;
 stack< pair<int,char> > s;

 s.n = 0;

 for(int i = 0; i < MAX; i++) {
   p.first = i; p.second = 'r' + i; push(s,p);
 }

 while(!isEmpty(s)) cout << pop(s).second << endl;
 return 0;
}
