#ifndef STACK_H                  // Fichier Stack.h
#define STACK_H

#include <assert.h>

#include <iostream>

using namespace std;

template <class T>
class Stack;

template <class T>                                    // Pour les fonctions
ostream& operator<<(ostream& os, const Stack<T>& s);  // friend template.
                                                      // Il faut aussi <>
const int MAX = 10;

template <class T>
class Stack {

   friend ostream& operator<< <>(ostream& os, const Stack<T>& s);

 public :
            Stack(void) : _size(0) {}
            Stack(const Stack<T>& s) { _copy(s); }
            Stack<T>& operator=(const Stack<T>& s) {
                                                    if (this != &s)
                                                    {
                                                     _destroy();
                                                     _copy(s);
                                                    }
                                                    return *this;
                                                   }
   virtual ~Stack(void) {}
   bool empty(void) const   { return _size == 0; }
   int  size(void) const    { return _size;      }
   const T& top(void) const { assert(!empty()); return _stack[_size - 1]; }
   void push(const T& t)    { assert(_size < MAX); _stack[_size++] = t;   }
   T pop(void)              { assert(!empty()); return _stack[--_size];   }

 private :

   T _stack[MAX];
   int _size;

   void _copy(const Stack<T>& s) {
                                   _size = s._size;
                                   for(int i=0; i< _size; i++)
                                   {
                                    _stack[i] = s._stack[i];
                                   }
                                 }
   void _destroy(void) {}
};

template <class T>
ostream& operator<<(ostream& os, const Stack<T>& s)
{
 os << endl ;
 os << " Une Stack<T> :" << endl;
 for(int i=s._size-1; i>=0; i--)
 {
  if (s._size==1)   os << "sommet & fond : ";
  else
  if (i==s._size-1) os << "       sommet : ";
  else
  if (i==0)         os << "         fond : ";
  else              os << "                ";

  os << s._stack[i];

  os << endl;
 }
 os << "~~~~~~~~~~~~~~~" << endl;

 return os;
}

#endif // STACK_H
