#ifndef STACK_H                  // Fichier Stack.h
#define STACK_H

#include <iostream>

using namespace std;

template <class T>
class Stack;

template <class T>                                    // Pour les fonctions
ostream& operator<<(ostream& os, const Stack<T>& s);  // friend template.
                                                      // Il faut aussi <> !
const int MAX = 10;

export                 // ... En theorie, si on ajoute export, ca evite le
template <class T>     // #include "Stack.cpp" dans le fichier du prg principal
class Stack {

   friend ostream& operator<< <>(ostream& os, const Stack<T>& s); 

 public :
            Stack(void);
            Stack(const Stack<T>& s);
            Stack<T>& operator=(const Stack<T>& s);
   virtual ~Stack(void);
   bool empty(void) const;
   int size(void) const;
   const T& top(void) const;
   void push(const T& t);
   T pop(void);

 private :

   T _stack[MAX];
   int _size;

   void _copy(const Stack<T>& s);
   void _destroy(void);
};

#endif // STACK_H
