#ifndef DYNAMICARRAY_H          // DynamicArray.h : // tableau homogene
#define DYNAMICARRAY_H

// Pour les fonctions friend template :
// http://gnu.cict.fr/software/gcc/faq.html#friend

#include <iostream>

#include "AbstractArray.h"

using namespace std;

template <class T>
class DynamicArray;

template <class T>
DynamicArray<T> operator+(const DynamicArray<T>& a1,
                          const DynamicArray<T>& a2);

// export             // ... En theorie, si on ajoute export, ca evite le
template <class T>    // #include "DynamicArray.cpp du fichier du prg principal
class DynamicArray : public AbstractArray<T>
{
  public:

    // Constructeurs/destructeur

     DynamicArray(int capacity = MAX);         // Constructeur par defaut
     DynamicArray(const DynamicArray<T>& t);  // Constructeur par recopie
     DynamicArray<T>& operator=(const DynamicArray<T>& t); // Affectation
     DynamicArray(const T* CArray, int capacity);// Constructeur par cousinage
     virtual ~DynamicArray(void);                          // Destructeur

    // Modifieurs

     virtual void insert(const T& element);      // virtuelle

    // Operateurs

            DynamicArray<T>& operator+=(const DynamicArray<T>& a);
     friend DynamicArray<T> operator+ <>(const DynamicArray<T>& a1,
                                         const DynamicArray<T>& a2);

  private:

   // Utilitaires prives de : copie, desallocation, reallocation

     virtual void _copy(const DynamicArray<T>& t); // virtuelle
     virtual void _destroy(void);                  // virtuelle
     virtual void _realloc(int newCapacity);       // virtuelle
  
};
#endif // DYNAMICARRAY_H
