#ifndef STATICARRAY_H          // StaticArray.h : // tableau homogene
#define STATICARRAY_H

// Pour les fonctions friend template :
// http://gnu.cict.fr/software/gcc/faq.html#friend

#include <iostream>

#include "AbstractArray.h"

using namespace std;

template <class T>
class StaticArray;

template <class T>
StaticArray<T> operator+(const StaticArray<T>& a1,
                         const StaticArray<T>& a2);

// export             // ... En theorie, si on ajoute export, ca evite le
template <class T>    // #include "StaticArray.cpp du fichier du prg principal
class StaticArray : public AbstractArray<T>
{
  public:

    // Constructeurs/destructeur

     StaticArray(void);                     // Constructeur par defaut
     StaticArray(const StaticArray<T>& t);  // Constructeur par recopie
     StaticArray<T>& operator=(const StaticArray<T>& t); // Affectation
     StaticArray(const T* CArray, int capacity);// Constructeur par cousinage
     virtual ~StaticArray(void);                          // Destructeur

    // Modifieurs

     virtual void insert(const T& element);      // virtuelle

    // Operateurs

            StaticArray<T>& operator+=(const StaticArray<T>& a);
     friend StaticArray<T> operator+ <>(const StaticArray<T>& a1,
                                        const StaticArray<T>& a2);

  private:

   // Tableau interne static

            T _st[MAX];

   // Utilitaires prives de : copie, desallocation

     virtual void _copy(const StaticArray<T>& t);  // virtuelle
     virtual void _destroy(void);                  // virtuelle
  
};
#endif // STATICARRAY_H
