                   // Fichier genere avec ./genere -t3 Derived
#include "Derived.h"

//--
template <class T1, class T2, class T3>
Derived<T1,T2,T3>::Derived(void) : Base<T1,T2>(), _derivedObject(T3())
{
}

//--
template <class T1, class T2, class T3>
Derived<T1,T2,T3>::Derived(const Derived<T1,T2,T3>& aD) : Base<T1,T2>(aD)
{
 _copy(aD);
}

//--
template <class T1, class T2, class T3>
Derived<T1,T2,T3>& Derived<T1,T2,T3>::operator=(const Derived<T1,T2,T3>& aD)
{
 if (this != &aD)
 {
  Base<T1,T2>::operator=(aD);
  _destroy();
  _copy(aD);
 }
 return *this;
}

//--
template <class T1, class T2, class T3>
Derived<T1,T2,T3>::~Derived(void)
{
 _destroy();
}

//--
template <class T1, class T2, class T3>
bool operator==(const Derived<T1,T2,T3>& aD1,
                const Derived<T1,T2,T3>& aD2)
{
 return aD1.isEqualTo(aD2);
}

//--
template <class T1, class T2, class T3>
bool operator!=(const Derived<T1,T2,T3>& aD1,
                const Derived<T1,T2,T3>& aD2)
{
 return !(aD1==aD2);
}

//--
template <class T1, class T2, class T3>
void Derived<T1,T2,T3>::setDerivedObject(const T3& object)
{
 _derivedObject = object;
}

template <class T1, class T2, class T3>
const T3& Derived<T1,T2,T3>::getDerivedObject(void) const
{
 return _derivedObject;
}

//--
template <class T1, class T2, class T3>
ostream& operator<<(ostream& os, const Derived<T1,T2,T3>& aD)
{
 aD.display(os);
 return os;
}

//--
template <class T1, class T2, class T3>
void Derived<T1,T2,T3>::display(ostream& os) const
{
 os << '(';
 Base<T1,T2>::display(os);
 os << ',' << _derivedObject << ')';
}

//--
template <class T1, class T2, class T3>
bool Derived<T1,T2,T3>::isEqualTo(const Derived<T1,T2,T3>& aD) const
{
 if (_derivedObject != aD._derivedObject) return false;

 if (!(Base<T1,T2>::isEqualTo(aD))) return false;
 return true;
}

//--
template <class T1, class T2, class T3>
void Derived<T1,T2,T3>::_copy(const Derived<T1,T2,T3>& aD)
{
 _derivedObject = aD._derivedObject;
}

//--
template <class T1, class T2, class T3>
void Derived<T1,T2,T3>::_destroy(void)
{
}

