                   // Fichier genere avec ./genere -t3 Derived
#ifndef _DERIVED_H_
#define _DERIVED_H_

#include <iostream>

#include "Base.h"

using namespace std;


//---- Pour les classes template avec fonctions amies

template <class T1, class T2, class T3> class Derived;

template <class T1, class T2, class T3>
ostream& operator<<(ostream& os, const Derived<T1,T2,T3>& aD);

template <class T1, class T2, class T3>
bool operator==(const Derived<T1,T2,T3>& aD1,
                const Derived<T1,T2,T3>& aD2);

template <class T1, class T2, class T3>
bool operator!=(const Derived<T1,T2,T3>& aD1,
                const Derived<T1,T2,T3>& aD2);

//---------------------------------------------------

//export
template <class T1, class T2, class T3>
class Derived : public Base<T1,T2>
{
   friend ostream& operator<< <>(ostream& os, const Derived<T1,T2,T3>& aD);

 public :

   // Allocateurs/Desallocateurs

            Derived(void);
            Derived(const Derived<T1,T2,T3>& aD);
            Derived<T1,T2,T3>& operator=(const Derived<T1,T2,T3>& aD);
   virtual ~Derived(void);

   // Comparaisons

   friend  bool operator== <>(const Derived<T1,T2,T3>& aD1,
                              const Derived<T1,T2,T3>& aD2);
   friend  bool operator!= <>(const Derived<T1,T2,T3>& aD1,
                              const Derived<T1,T2,T3>& aD2);

   // Inspecteurs/modificateurs

        void setDerivedObject(const T3& object);
   const T3& getDerivedObject(void) const;

 protected :

   // Methodes a appeler par une classe derivee

   // display: a appeler dans une classe derivee      // display est une
   virtual void display(ostream& os) const;           // methode appelee
                                                      // dans operator<<

   // isEqualTo: a appeler dans une classe derivee (dans operator==)
           bool isEqualTo(const Derived<T1,T2,T3>& aD) const;

 protected :

             // ###

 private :

             T3 _derivedObject;

 private :

   // Methodes privees d'allocation/desallocation

   void _copy(const Derived<T1,T2,T3>& aD);
   void _destroy(void);
};

#endif // _DERIVED_H_
